import { IState, IAction, IAsyncAction, ICloner, IStore } from "./";
import { IStateNotifier } from "./../observer";
export declare class Store implements IStore {
    private cloner;
    private notifier;
    private state;
    private cloneState();
    private updateState(state);
    constructor(initialState: IState, cloner: ICloner, notifier: IStateNotifier);
    dispatch(action: IAction | ((state: IState) => IState)): IState;
    dispatchAsync(action: IAsyncAction | ((state: IState, resolve: (value?: IState) => void, reject: (errors?: any) => void) => void)): Promise<IState>;
    getState<TState extends IState>(): TState;
}
